include:
  - local: /templates/default.yml


.kaniko:
  extends:
    - .default_job
  stage: build
  image:
    # For latest releases see https://github.com/GoogleContainerTools/kaniko/releases
    # Only debug/*-debug versions of the Kaniko image are known to work within Gitlab CI
    name: gcr.io/kaniko-project/executor:debug
    entrypoint: [""]
  variables:
    BUILD_ARGS: --verbosity=info
    BUILD_CONTEXT: ${CI_PROJECT_DIR}/build
    DOCKERFILE: ${CI_PROJECT_DIR}/build/Dockerfile
    IMAGE_TAG: ""
    REGISTRY_URL: ${CI_REGISTRY_URL}
    REGISTRY_USER: ${CI_REGISTRY_USER}
    REGISTRY_PASSWORD: ${CI_REGISTRY_PASSWORD}
  before_script:
    - !reference [.functions, script]
    - check_variables_defined REGISTRY_URL REGISTRY_USER REGISTRY_PASSWORD IMAGE_TAG
    - mkdir -p /kaniko/.docker
    - |
      cat <<END > /kaniko/.docker/config.json
      {
        "auths": {
          "$REGISTRY_URL": {
            "username": "$REGISTRY_USER",
            "password": "$REGISTRY_PASSWORD"
          }
        }
      }
      END
    - export KANIKO_CACHE_REPO="$(echo $IMAGE_TAG | sed -E 's/(.+)\/(.+):.+/\1\/\2-cache/')"
    - export IMAGE_TAG="$(echo $IMAGE_TAG | sed -E 's/(.*):v(.*)/\1:\2/g')"
    - log_section "Storing dotenv"
    - |
      cat <<EOF > artifacts.env
      IMAGE_TAG=${IMAGE_TAG}
      REGISTRY_URL=${REGISTRY_URL}
      EOF
  script:
    - log_section "Building Image with tag '$IMAGE_TAG'"
    - >
      /kaniko/executor
      --context ${BUILD_CONTEXT}
      --dockerfile ${DOCKERFILE}
      --cache=true
      --cache-repo=${KANIKO_CACHE_REPO}
      --destination ${IMAGE_TAG}
      ${BUILD_ARGS}
  after_script:
    - cat artifacts.env
  artifacts:
    reports:
      dotenv: artifacts.env

.retag:
  image:
    name: gcr.io/go-containerregistry/crane:debug
    entrypoint: [""]
  variables:
    GIT_STRATEGY: none
    SRC_IMAGE_TAG: ""
    DST_IMAGE_TAG: ""
    REGISTRY_URL: ${CI_REGISTRY_URL}
    REGISTRY_USER: ${CI_REGISTRY_USER}
    REGISTRY_PASSWORD: ${CI_REGISTRY_PASSWORD}
  before_script:
    - !reference [.functions, script]
    - check_variables_defined REGISTRY_URL REGISTRY_USER REGISTRY_PASSWORD SRC_IMAGE_TAG DST_IMAGE_TAG
  script:
    - crane auth login -u $REGISTRY_USER -p $REGISTRY_PASSWORD $CI_REGISTRY
    - crane cp ${SRC_IMAGE_TAG} ${DST_IMAGE_TAG}
